#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import math
import numpy as np

import collections
import heapq

import GridMap as gmap


class GridPlanner:

    def __init__(self):
        pass

    def plan(self, gridmap, start, goal, neigh):
        """
        Method to plan the path

        Parameters
        ----------
        gridmap: GridMap
            gridmap of the environment
        start: (int,int)
            start coordinates
        goal:(int,int)
            goal coordinates
        neigh:string(optional)
            type of neighborhood for planning ('N4' - 4 cells, 'N8' - 8 cells)

        Returns
        -------
        list(int,int)
            the path between the start and the goal if there is one, None if there is no path
        """
        came_from = self.a_star_search(gridmap, start, goal, neigh)
        if not goal in came_from:
            return {}
        path = self.reconstruct_path(came_from, start, goal)
        return path
    
    #########################################
    # A_STAR
    #########################################
    

    def a_star_search(self, graph, start, goal, neigh):
        """
        This is the function for you to implement.
        
        Parameters
        ----------
        graph: GridMap
            gridmap of the environment
        start: (int,int)
            start coordinates
        goal: (int,int)
            goal coordinates
        neigh:string(optional)
            type of neighborhood for planning ('N4' - 4 cells, 'N8' - 8 cells)
            
        Returns
        -------
        dict (int,int) -> (int, int)
            for every node in path give his predecessor.
        """
        
        # TODO: implement your search alg.
            
        return {}
    
    
    
    #########################################
    # backtracking function
    #########################################
    
    def reconstruct_path(self, came_from, start, goal):
        current = goal
        path = [current]
        while current != start:
            current = came_from[current]
            path.append(current)
        path.append(start) # optional
        path.reverse() # optional
        return path
